<template>
  <div class="ob-questionnaire">
    <div
      v-if="previewMode"
      class="ob-questionnaire-preview-alert"
    >
      Предварительный просмотр

      <i
        class="icon close ob-questionnaire-preview-alert__close"
        :data-qa="dataQa"
        @click="togglePreview"
      />
    </div>

    <ObFuncPanel
      v-if="showFuncPanel"
      :show-add-button="showAddButton"
      :show-group="false"
      :show-filter="false"
      :show-search="true"
      :show-column-filter="false"
      :show-sort="false"
      :columns="[]"
      add-button-text="Добавить раздел или вопрос"
      :data-qa="dataQa"
      @add="addHandler"
      @search="onSearch"
    >
      <template slot="extraFuncToPanel">
        <slot name="extraFuncToPanel" />
      </template>
    </ObFuncPanel>

    <slot
      v-if="(!groups || !groups.length || isNoneContent) && !isAddUserQuestions"
      name="noneContent"
    />

    <div
      v-else
      class="row"
    >
      <div class="col-xs-9">
        <div class="ob-questionnaire-accordion">
          <QuestionnaireGroup
            v-for="(group, i) in processedGroups"
            :key="i"
            ref="group"
            :group-data="group"
            :fill-mode="fillMode"
            :fields-disabled="fieldsDisabled"
            :counters-disabled="countersDisabled"
            :preview-mode="previewMode"
            :data-uuid="group.uuid"
            :data-qa="dataQa"
            :is-group-opened="openedGroups.includes(group.uuid)"
            @toggle-group="toggleGroup"
            @weight-changed="onWeightChanged"
            @check-filled="checkQuestionnaireIsFilled"
            @field-changed="onAnyFieldChanged"
            @comment-changed="onCommentChanged"
            @user-question-blur="blurUserQuestion"
            @user-question-added="addUserQuestion"
            @user-question-modified="modifiedUserQuestion"
            @delete-group="deleteGroup"
            @delete-question="deleteQuestion"
          />
        </div>
      </div>

      <div :class="[ countersDisabled || previewMode ? 'col-xs-2 col-xs-offset-1' : 'col-xs-3' ]">
        <div class="ob-questionnaire-right-block">
          <QuestionnaireStats
            :fill-mode="fillMode"
            :fields-disabled="fieldsDisabled"
            :counters-disabled="countersDisabled"
            :preview-mode="previewMode"
            :groups="sortedGroups"
            :opened-groups="openedGroups"
            :visible-group="lastVisibleGroup"
            :data-qa="dataQa"
            :passing-score="passingScore"
            @open-group="onGroupClick"
            @toggle-preview="onPreviewClick"
            @state-changed="onStateChanged"
            @set-state="setState"
            @passing-score-status-changed="onPassingScoreStatusChanged"
            @passing-score-changed="onPassingScoreChanged"
          />

          <ObAlert
            v-if="!countersDisabled && !previewMode && isEmptyUserQuestionExists"
            :hide-close-button="true"
            theme="info-flat"
            icon="info"
          >
            В разделе «Дополнительные вопросы» есть вопрос без текста. Напишите
            текст или удалите вопрос. Вопросы без текста не показываются поставщикам.
          </ObAlert>

          <slot name="rightColumnBottom" />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import ObFuncPanel from '../obFuncPanel'
import ObAlert from '../obAlert'

import QuestionnaireGroup from './components/questionnaireGroup'
import QuestionnaireStats from './components/questionnaireStats'
import QuestionnaireMixin from './components/questionnaireMixin'

import { uuid } from 'vue-uuid'
import cloneDeep from 'clone-deep'

export default {
  name: 'ObQuestionnaire',
  components: {
    ObFuncPanel,
    ObAlert,
    QuestionnaireGroup,
    QuestionnaireStats
  },
  mixins: [
    QuestionnaireMixin
  ],
  props: {
    showFuncPanel: {
      type: Boolean,
      default: true
    },
    showAddButton: {
      type: Boolean,
      default: true
    },
    isNoneContent: {
      type: Boolean,
      default: false
    },
    isAddUserQuestions: {
      type: Boolean,
      default: false
    },
    groups: {
      type: [ Array, null ],
      default: () => []
    },
    passingScore: {
      type: [ Number, null ],
      default: undefined
    }
  },
  data () {
    return {
      opened: false,
      previewMode: false,
      isStateCheckingAwaiting: false,
      openedGroups: [],
      visibleGroups: [],
      searchQuery: null,
      isQuestionnaireFilled: false
    }
  },
  computed: {
    sortedGroups () {
      const groups = this.groups
      let isUserQuestionGroupExists = false

      // Сортировка всех групп, вопросов и полей
      groups.map((group) => {
        if (group.isUserQuestionsAvailable) {
          isUserQuestionGroupExists = true
        }

        group.questions = group.questions.map((question) => {
          let selectedRadio = ''

          question.fields = question.fields.map((field) => {
            if (question.type === 'SELECT' && field.value) {
              selectedRadio = field.uuid
            }

            return {
              ...field,
              value: field.value || this.getDefaultValue(field.type),
              weight: field.weight || 0
            }
          }).sort((a, b) => {
            return a.pos - b.pos
          })

          return {
            ...question,
            ...(question.type === 'SELECT' && { selected: selectedRadio || (question.selected || '') })
          }
        }).sort((a, b) => {
          return a.pos - b.pos
        })

        return group
      })

      // There is 2 cases:
      // 1. If user question group exists, using it in priority;
      // 2. Using blank first question if 'isAddUserQuestions' prop is 'true'.
      if (!isUserQuestionGroupExists && this.isAddUserQuestions) {
        groups.push({
          uuid: uuid.v4(),
          title: 'Дополнительные вопросы (напишите здесь свои вопросы)',
          pos: 9999, // Always last group in list
          isUserQuestionsAvailable: true,
          questions: [{
            uuid: uuid.v4(),
            type: 'TEXT',
            isUserQuestion: true,
            fields: [{
              title: 'Ответ',
              type: 'TEXT',
              uuid: uuid.v4(),
              isUserQuestionsAvailable: true
            }]
          }]
        })
      }

      return groups.sort((a, b) => {
        return a.pos - b.pos
      })
    },
    processedGroups () {
      if (!this.searchQuery) {
        return this.sortedGroups
      }

      return this.sortedGroups.map((group) => {
        return {
          ...group,
          questions: group.questions.filter((question) => {
            return question.title.toLowerCase().includes(this.searchQuery)
          })
        }
      }).filter((group) => {
        return group.questions.length
      })
    },
    userQuestionsGroup () {
      return this.groups[this.groups.length - 1]
    },
    isEmptyUserQuestionExists () {
      return this.groups.some(g => g.isUserQuestionsAvailable && g.questions.some(q => !q.title))
    },
    lastVisibleGroup () {
      return this.visibleGroups[this.visibleGroups.length - 1]
    }
  },
  created () {
    let previousY = 0

    this.observer = new IntersectionObserver((entries) => {
      const currentY = window.scrollY

      entries.forEach((entry) => {
        const uuid = entry.target.dataset.uuid

        if (entry.intersectionRatio === 0) {
          this.visibleGroups = this.visibleGroups.filter(item => item !== uuid)
        } else if (!this.visibleGroups.includes(uuid)) {
          // Scrolling down/up
          if (currentY >= previousY) {
            this.visibleGroups.push(uuid)
          } else {
            this.visibleGroups.unshift(uuid)
          }
        }

        previousY = currentY
      })
    })
  },
  methods: {
    addHandler (it) {
      this.$emit('add', it)
    },
    toggleGroup (groupUuid, onlyOpening = false) {
      const groupIndex = this.processedGroups.findIndex(group => groupUuid === group.uuid)

      const groupElement = this.$refs.group[groupIndex].$el

      if (!this.openedGroups.includes(groupUuid)) {
        this.openedGroups.push(groupUuid)

        this.observer.observe(groupElement)
      } else if (!onlyOpening) {
        this.openedGroups = this.openedGroups.filter(uuid => uuid !== groupUuid)

        this.observer.unobserve(groupElement)
      }
    },
    onGroupClick (data) {
      this.toggleGroup(data.group.uuid, true)

      // Set group header to the center of screen (TND-1304)
      this.$refs.group[data.index].$el.children[0].scrollIntoView({
        behavior: 'smooth',
        block: 'center'
      })
    },
    togglePreview () {
      this.previewMode = !this.previewMode
    },
    onPreviewClick () {
      this.togglePreview()
    },
    onWeightChanged (question) {
      this.$emit('weight-changed', question)
    },
    setState (state) {
      this.isQuestionnaireFilled = state
    },
    onStateChanged (isFilled) {
      if (isFilled !== this.isQuestionnaireFilled && this.isStateCheckingAwaiting) {
        this.$emit('state-changed')

        this.isQuestionnaireFilled = isFilled
        this.isStateCheckingAwaiting = false
      }
    },
    checkQuestionnaireIsFilled () {
      this.isStateCheckingAwaiting = true
    },
    onAnyFieldChanged () {
      this.$emit('field-changed')
    },
    getDefaultValue (type) {
      switch (type) {
        case 'TEXT':
        case 'TIME':
        case 'DATE':
          return ''

        case 'NUMBER':
          return 0

        default:
          return false
      }
    },
    onSearch (query) {
      this.searchQuery = query.toLowerCase()

      this.$emit('search')
    },
    blurUserQuestion () {
      this.$emit('user-question-blur')
    },
    addUserQuestion () {
      const newUuid = uuid.v4()
      const questionCopy = cloneDeep(this.userQuestionsGroup.questions[0])

      this.userQuestionsGroup.questions.push({
        ...questionCopy,
        uuid: newUuid,
        title: null,
        pos: questionCopy.pos + 1,
        fields: [{
          ...questionCopy.fields[0],
          value: null
        }]
      })

      this.$emit('user-question-added', newUuid, this.userQuestionsGroup.uuid)
    },
    modifiedUserQuestion (uuid, title) {
      this.$emit('user-question-modified', uuid, title, this.userQuestionsGroup.uuid)
    },
    deleteGroup (uuid, isUserGroup) {
      this.$emit('delete-group', uuid, isUserGroup)
    },
    deleteQuestion (uuid, isUserQuestion) {
      this.$emit('delete-question', uuid, isUserQuestion)
    },
    onPassingScoreStatusChanged (status) {
      this.$emit('passing-score-status-changed', status)
    },
    onPassingScoreChanged (score) {
      this.$emit('passing-score-changed', score)
    },
    onCommentChanged () {
      this.$emit('comment-changed')
    }
  }
}
</script>

<style lang="scss" scoped>
  @import '../../static/css/main';
  @import '../../static/css/variables';

  .ob-questionnaire-preview-alert {
    background-color: $blue-250;
    padding: 20px;
    display: grid;
    grid-gap: 20px;
    grid-auto-flow: column;
    grid-template-columns: 1fr min-content;
    align-items: center;
    font-size: 16px;
    margin-bottom: 20px;

    &__close {
      color: $color-blue-navy-blue;
      font-size: 14px;
      cursor: pointer;
    }
  }

  .ob-questionnaire-right-block {
    position: sticky;
    transition: .2s top linear;
    top: calc(var(--header-max-height) + var(--tender-header-offset) + 2rem);
  }
</style>
